# A demo package for useful course material

This package is our toolbox for the programming lecture. You can use it as 
template for packages you will want to write for other lectures 
or your Master's thesis.

The package provides a standard python library with
several submodules, see *Package structure* below.
For example, you can import like

```
import mytoolbox
from mytoolbox import solar
```

## How-To

Follow the theory and instructions provided as [lecture material](https://pages.labs.fhv.at/~hefl/programmiertechniken/10A_packages.hmtl).


## Package structure

#### Directory root (``./``)

- ``LICENSE.txt``: [always](https://help.github.com/articles/licensing-a-repository/) license your code.
- ``README.md``: parts of this webpage, a markdown file `*.md`. This is a file type that contains only [Markdown](https://en.wikipedia.org/wiki/Markdown) text (as opposed to `*.ipynb` files that we use to mix python code with Markdown text).
- ``setup.py``: this setup file is what makes your package installable by a package manager. It
  contains a set of simple instructions regarding the name of the package,
  its version number, etc.
  
#### The actual package (``./mytoolbox``)

- ``__init__.py``: tells python that the directory is a package and enables
  the "dotted module names" import syntax (e.g., `import matplotlib.pyplot as plt`). Like in our case, this file is often empty.
- ``solar.py``: the first module in our package


## License

With the exception of the ``setup.py`` file which was adapted from the
[sampleproject](https://github.com/pypa/sampleproject) package, all the
code in this repository is dedicated to the public domain.
